// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once

#include <glad/glad.h>
#include <GLFW/glfw3.h>
#include "host/DawnHost.hpp"

#define DAWN_GLFW_WINDOW_WIDTH_DEFAULT 1280
#define DAWN_GLFW_WINDOW_HEIGHT_DEFAULT 720

#define DAWN_GLFW_INIT_RESULT_INIT_FAILED -1
#define DAWN_GLFW_INIT_RESULT_WINDOW_CREATE_FAILED -2

#define DAWN_GLFW_START_RESULT_UPDATE_FAILED -1

namespace Dawn {
  class DawnHostData {
    public:
      GLFWwindow *window;
  };
}

// GLFW Callbacks
void glfwOnError(int error, const char* description);
void glfwOnResize(GLFWwindow *window, int32_t width, int32_t height);